<template>
  <div/>
</template>

<script>
import { marker, icon } from 'leaflet'
import { SET_WORKSPACE_QUERY, REMOVE_WORKSPACE_CUSTOM_LOCAL } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LeafletGetter from '@/workspace/mixins/LeafletGetter'
import MarkerIconImage from '@/assets/images/map-marker.png'

const malmoLocationIcon = icon({
  iconUrl: MarkerIconImage,
  iconSize: [32, 32],
  iconAnchor: [16, 16]
})

export default {
  name: 'customlocationmarker',

  mixins: [
    WorkspaceGetter,
    LeafletGetter,
  ],

  computed: {
    location: {
      get() {
        return this.$store.getters.workspaceLocationById(
          this.workspaceId,
          this.$store.getters.workspaceCustomLocation(this.workspaceId)
        )
      }
    },
  },

  mounted() {
    this.__markerObject = marker([this.location.latitude, this.location.longitude], {
      icon: malmoLocationIcon
    })

    this.$store.commit(SET_WORKSPACE_QUERY, {
      workspaceId: this.workspaceId,
      query: {
        isStation: false,
        latitude: this.location.latitude,
        longitude: this.location.longitude
      }
    })

    this.__markerObject.addTo(this.leafletMap)
  },

  destroyed() {
    this.$store.commit(REMOVE_WORKSPACE_CUSTOM_LOCAL, {
      workspaceId: this.workspaceId
    })
    this.__markerObject.remove()
  }
}
</script>
